# std::ios_base Class Reference

The very top of the I/O class hierarchy. More...

`#include <ios_base.h>`

Inheritance diagram for std::ios_base:

[legend]
List of all members.

## Public Types

typedef _Ios_Fmtflags | fmtflags
| This is a bitmask type.
typedef _Ios_Iostate | iostate
| This is a bitmask type.
typedef _Ios_Openmode | openmode
| This is a bitmask type.
typedef _Ios_Seekdir | seekdir
| This is an enumerated type.
typedef void(* | event_callback )(event, ios_base &, int)
enum | event

## Public Methods

void | register_callback (event_callback __fn, int __index)
fmtflags | flags () const
| Access to format flags.
fmtflags | flags (fmtflags __fmtfl)
| Setting new format flags all at once.
fmtflags | setf (fmtflags __fmtfl)
| Setting new format flags.
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
| Setting new format flags.
void | unsetf (fmtflags __mask)
| Clearing format flags.
streamsize | precision () const
| Flags access.
streamsize | precision (streamsize __prec)
| Changing flags.
streamsize | width () const
| Flags access.
streamsize | width (streamsize __wide)
| Changing flags.
locale | imbue (const locale &__loc)
| Setting a new locale.
locale | getloc () const
| Locale access.
long & | iword (int __ix)
void *& | pword (int __ix)
virtual | ~ios_base ()

## Static Public Methods

bool | sync_with_stdio (bool __sync=true)
| Interaction with the standard C I/O objects.
int | xalloc () throw ()

## Static Public Attributes

const fmtflags | boolalpha
| Insert/extract `bool` in alphabetic rather than numeric format.
const fmtflags | dec
| Converts integer input or generates integer output in decimal base.
const fmtflags | fixed
| Generate floating-point output in fixed-point notation.
const fmtflags | hex
| Converts integer input or generates integer output in hexadecimal base.
const fmtflags | internal
| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.
const fmtflags | left
| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).
const fmtflags | oct
| Converts integer input or generates integer output in octal base.
const fmtflags | right
| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).
const fmtflags | scientific
| Generates floating-point output in scientific notation.
const fmtflags | showbase
| Generates a prefix indicating the numeric base of generated integer output.
const fmtflags | showpoint
| Generates a decimal-point character unconditionally in generated floating-point output.
const fmtflags | showpos
| Generates a + sign in non-negative generated numeric output.
const fmtflags | skipws
| Skips leading white space before certain input operations.
const fmtflags | unitbuf
| Flushes output after each output operation.
const fmtflags | uppercase
| Replaces certain lowercase letters with their uppercase equivalents in generated output.
const fmtflags | adjustfield
| A mask of left|right|internal. Useful for the 2-arg form of `setf.`
const fmtflags | basefield
| A mask of dec|oct|hex. Useful for the 2-arg form of `setf.`
const fmtflags | floatfield
| A mask of scientific|fixed. Useful for the 2-arg form of `setf.`
const iostate | badbit
| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).
const iostate | eofbit
| Indicates that an input operation reached the end of an input sequence.
const iostate | failbit
| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.
const iostate | goodbit
| Indicates all is well.
const openmode | app
| Seek to end before each write.
const openmode | ate
| Open and seek to end immediately after opening.
const openmode | binary
| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more.
const openmode | in
| Open for input. Default for `ifstream` and fstream.
const openmode | out
| Open for output. Default for `ofstream` and fstream.
const openmode | trunc
| Open for input. Default for `ofstream.`
const seekdir | beg
| Request a seek relative to the beginning of the stream.
const seekdir | cur
| Request a seek relative to the current position within the sequence.
const seekdir | end
| Request a seek relative to the current end of the sequence.

## Detailed Description

The very top of the I/O class hierarchy.

This class defines everything that can be defined about I/O that does not depend on the type of characters being input or output. Most people will only see `ios_base` when they need to specify the full name of the various I/O flags (e.g., the openmodes).

Definition at line 156 of file ios_base.h.

## Member Typedef Documentation

typedef void(* std::ios_base::event_callback)(event, ios_base&, int)

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 353 of file ios_base.h.

typedef _Ios_Fmtflags std::ios_base::fmtflags

This is a bitmask type.

`"_Ios_Fmtflags"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 210 of file ios_base.h.

Referenced by flags() , setf() , and unsetf() .

typedef _Ios_Iostate std::ios_base::iostate

This is a bitmask type.

`"_Ios_Iostate"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 267 of file ios_base.h.

Referenced by std::basic_ios< char, _Traits >::exceptions() , and std::basic_ios< char, _Traits >::setstate() .

typedef _Ios_Openmode std::ios_base::openmode

This is a bitmask type.

`"_Ios_Openmode"` is implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 294 of file ios_base.h.

Referenced by __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf() .

typedef _Ios_Seekdir std::ios_base::seekdir

This is an enumerated type.

`"_Ios_Seekdir"` is implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 321 of file ios_base.h.

## Member Enumeration Documentation

enum std::ios_base::event

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 343 of file ios_base.h.

## Constructor & Destructor Documentation

std::ios_base::~ios_base | ( |  | ) | `[virtual]`

| Destroys local storage and [XXX does something with callbacks]. Definition at line 312 of file ios.cc.

## Member Function Documentation

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) | `[inline]`

Setting new format flags all at once.

Parameters:

  fmtfl | The new flags to set.

Returns:
  The previous format control flags.

This function overwrites all the format flags with fmtfl.

Definition at line 473 of file ios_base.h.

References fmtflags .

fmtflags std::ios_base::flags | ( |  | ) | const`[inline]`

Access to format flags.

Returns:
  The format control flags for both input and output.

Definition at line 463 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt() , std::basic_ostream< _CharT, _Traits >::operator<<() , std::basic_ostream< char >::operator<<() , std::basic_istream< _CharT, _Traits >::sentry::sentry() , and std::basic_ostream< _CharT, _Traits >::sentry::~sentry() .

locale std::ios_base::getloc | ( |  | ) | const`[inline]`

Locale access.

Returns:
  The locale currently in effect.

If `imbue(loc)` has previously been called, then this function returns `loc.` Otherwise, it returns a copy of `std::locale(),` the global C++ locale.

Definition at line 605 of file ios_base.h.

Referenced by std::operator>>() , and std::ws() .

locale std::ios_base::imbue | ( | const locale & | __loc | ) |

Setting a new locale.

Parameters:

  loc | The new locale.

Returns:
  The previous locale.

Sets the new locale for this stream, and [XXX does something with callbacks].

Reimplemented in std::basic_ios< _CharT, _Traits > , and std::basic_ios< char, _Traits > .

Definition at line 296 of file ios.cc.

long& std::ios_base::iword | ( | int | __ix | ) | `[inline]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 618 of file ios_base.h.

streamsize std::ios_base::precision | ( | streamsize | __prec | ) | `[inline]`

Changing flags.

Parameters:

  prec | The new precision value.

Returns:
  The previous value of precision().

Definition at line 541 of file ios_base.h.

streamsize std::ios_base::precision | ( |  | ) | const`[inline]`

Flags access.

Returns:
  The precision to generate on certain output operations.

Definition at line 533 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt() .

void*& std::ios_base::pword | ( | int | __ix | ) | `[inline]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 629 of file ios_base.h.

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index
| ) |

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 324 of file ios.cc.

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask
| ) | `[inline]`

Setting new format flags.

Parameters:

  fmtfl | Additional flags to set.
  mask | The flags mask for fmtfl.

Returns:
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield.`

Definition at line 506 of file ios_base.h.

References fmtflags .

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) | `[inline]`

Setting new format flags.

Parameters:

  fmtfl | Additional flags to set.

Returns:
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 489 of file ios_base.h.

References fmtflags .

Referenced by std::boolalpha() , std::dec() , std::fixed() , std::hex() , std::internal() , std::left() , std::oct() , std::right() , std::scientific() , std::showbase() , std::showpoint() , std::showpos() , std::skipws() , std::unitbuf() , and std::uppercase() .

bool std::ios_base::sync_with_stdio | ( | bool | __sync = true | ) | `[static]`

Interaction with the standard C I/O objects.

Parameters:

  sync | Whether to synchronize or not.

Returns:
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#8 for more.

Definition at line 355 of file ios.cc.

void std::ios_base::unsetf | ( | fmtflags | __mask | ) | `[inline]`

Clearing format flags.

Parameters:

  mask | The flags to unset.

This function clears mask in the format flags.

Definition at line 521 of file ios_base.h.

References fmtflags .

Referenced by std::noboolalpha() , std::noshowbase() , std::noshowpoint() , std::noshowpos() , std::noskipws() , std::nounitbuf() , and std::nouppercase() .

streamsize std::ios_base::width | ( | streamsize | __wide | ) | `[inline]`

Changing flags.

Parameters:

  wide | The new width value.

Returns:
  The previous value of width().

Definition at line 563 of file ios_base.h.

streamsize std::ios_base::width | ( |  | ) | const`[inline]`

Flags access.

Returns:
  The minimum field width to generate on output operations.

"Minimum field width" refers to the number of characters.

Definition at line 555 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt() , std::operator<<() , and std::operator>>() .

int std::ios_base::xalloc | ( |  | ) | throw ()`[static]`

Todo:
  Doc me! See docs/doxygen/TODO and http://gcc.gnu.org/ml/libstdc++/2002-02/msg00003.html for more.

Definition at line 231 of file ios.cc.

## Member Data Documentation

const ios_base::fmtflags std::ios_base::adjustfield`[static]`

| A mask of left|right|internal. Useful for the 2-arg form of `setf.` Definition at line 122 of file ios.cc.

const ios_base::openmode std::ios_base::app`[static]`

| Seek to end before each write. Definition at line 131 of file ios.cc.

const ios_base::openmode std::ios_base::ate`[static]`

| Open and seek to end immediately after opening. Definition at line 132 of file ios.cc.

const ios_base::iostate std::ios_base::badbit`[static]`

| Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file). Definition at line 126 of file ios.cc. Referenced by std::basic_ios< char, _Traits >::bad() , std::basic_ios< _CharT, _Traits >::clear() , std::basic_ios< char, _Traits >::fail() , and std::basic_ios< _CharT, _Traits >::init() .

const ios_base::fmtflags std::ios_base::basefield`[static]`

| A mask of dec|oct|hex. Useful for the 2-arg form of `setf.` Definition at line 123 of file ios.cc.

const ios_base::seekdir std::ios_base::beg`[static]`

| Request a seek relative to the beginning of the stream. Definition at line 138 of file ios.cc.

const ios_base::openmode std::ios_base::binary`[static]`

| Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#3 and http://gcc.gnu.org/onlinedocs/libstdc++/27_io/howto.html#7 for more. Definition at line 133 of file ios.cc.

const ios_base::fmtflags std::ios_base::boolalpha`[static]`

| Insert/extract `bool` in alphabetic rather than numeric format. Definition at line 107 of file ios.cc.

const ios_base::seekdir std::ios_base::cur`[static]`

| Request a seek relative to the current position within the sequence. Definition at line 139 of file ios.cc.

const ios_base::fmtflags std::ios_base::dec`[static]`

| Converts integer input or generates integer output in decimal base. Definition at line 108 of file ios.cc.

const ios_base::seekdir std::ios_base::end`[static]`

| Request a seek relative to the current end of the sequence. Definition at line 140 of file ios.cc.

const ios_base::iostate std::ios_base::eofbit`[static]`

| Indicates that an input operation reached the end of an input sequence. Definition at line 127 of file ios.cc. Referenced by std::basic_ios< char, _Traits >::eof() .

const ios_base::iostate std::ios_base::failbit`[static]`

| Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters. Definition at line 128 of file ios.cc. Referenced by std::basic_ios< char, _Traits >::fail() .

const ios_base::fmtflags std::ios_base::fixed`[static]`

| Generate floating-point output in fixed-point notation. Definition at line 109 of file ios.cc.

const ios_base::fmtflags std::ios_base::floatfield`[static]`

| A mask of scientific|fixed. Useful for the 2-arg form of `setf.` Definition at line 124 of file ios.cc.

const ios_base::iostate std::ios_base::goodbit`[static]`

| Indicates all is well. Definition at line 129 of file ios.cc. Referenced by std::basic_ios< _CharT, _Traits >::init() .

const ios_base::fmtflags std::ios_base::hex`[static]`

| Converts integer input or generates integer output in hexadecimal base. Definition at line 110 of file ios.cc.

const ios_base::openmode std::ios_base::in`[static]`

| Open for input. Default for `ifstream` and fstream. Definition at line 134 of file ios.cc. Referenced by std::basic_istringstream< _CharT, _Traits, _Alloc >::basic_istringstream() .

const ios_base::fmtflags std::ios_base::internal`[static]`

| Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated. Definition at line 111 of file ios.cc.

const ios_base::fmtflags std::ios_base::left`[static]`

| Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.). Definition at line 112 of file ios.cc.

const ios_base::fmtflags std::ios_base::oct`[static]`

| Converts integer input or generates integer output in octal base. Definition at line 113 of file ios.cc.

const ios_base::openmode std::ios_base::out`[static]`

| Open for output. Default for `ofstream` and fstream. Definition at line 135 of file ios.cc. Referenced by std::basic_ostringstream< _CharT, _Traits, _Alloc >::basic_ostringstream() .

const ios_base::fmtflags std::ios_base::right`[static]`

| Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.). Definition at line 114 of file ios.cc.

const ios_base::fmtflags std::ios_base::scientific`[static]`

| Generates floating-point output in scientific notation. Definition at line 115 of file ios.cc.

const ios_base::fmtflags std::ios_base::showbase`[static]`

| Generates a prefix indicating the numeric base of generated integer output. Definition at line 116 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpoint`[static]`

| Generates a decimal-point character unconditionally in generated floating-point output. Definition at line 117 of file ios.cc.

const ios_base::fmtflags std::ios_base::showpos`[static]`

| Generates a + sign in non-negative generated numeric output. Definition at line 118 of file ios.cc.

const ios_base::fmtflags std::ios_base::skipws`[static]`

| Skips leading white space before certain input operations. Definition at line 119 of file ios.cc.

const ios_base::openmode std::ios_base::trunc`[static]`

| Open for input. Default for `ofstream.` Definition at line 136 of file ios.cc.

const ios_base::fmtflags std::ios_base::unitbuf`[static]`

| Flushes output after each output operation. Definition at line 120 of file ios.cc.

const ios_base::fmtflags std::ios_base::uppercase`[static]`

| Replaces certain lowercase letters with their uppercase equivalents in generated output. Definition at line 121 of file ios.cc.

The documentation for this class was generated from the following files:

- ios_base.h
- ios.cc